<?php

namespace Dalten\RuianToUir\Converter;

use Dalten\RuianToUir\Converter\Exception\InvalidRuianDataException;
use Dalten\RuianToUir\Converter\Field\PointCoordinatesConverter;
use Dalten\RuianToUir\Converter\Result\AddRecord;
use Dalten\RuianToUir\Converter\Result\ResultInterface;

/**
 * Převaděč na entitu městské ulice.
 */
class Street extends AbstractConverter implements ConverterInterface
{
    /**
     * Nastavuje konfiguraci třídy.
     *
     * @param PointCoordinatesConverter $coordinateConverter
     */
    public function __construct(PointCoordinatesConverter $coordinateConverter)
    {
        parent::__construct($coordinateConverter);
        $this->handledTag = 'vf:Ulice';
    }

    /**
     * Převádí informace z prvku pod kurzorem do formátu UIR.
     *
     * Protože RUIAN vkládá elementy ulice do sebe, zkusí tato třída zda daný prvek neobsahuje další podobný.
     * Pokud ano, pak zpracuje až vnitřní prvek. Bohužel je toto při přáci s XMLReaderem nutnost.
     *
     * @param \XMLReader $document instance readeru s kurzorem na testovaném prvku
     *
     * @return ResultInterface pole s daty ve formátu UIR
     */
    public function convert(\XMLReader $document): ResultInterface
    {
        $data = ['stav' => 1];

        $element = $this->getNextElement($document);

        if ($element instanceof \XMLReader && $element->name === $this->handledTag) {
            // pokud jsme narazili na tag ulice, který obsahuje další ulici, zpracujeme tu a tuhle přeskočíme
            $this->getNextElement($document);
        }

        do {
            switch ($document->name) {
                case 'uli:Kod':
                    $data['ulice_kod'] = (int) $document->readString();

                    break;
                case 'uli:Nazev':
                    $data['zkratka'] = $data['nazev'] = (string) $document->readString();

                    break;
                case 'uli:Obec':
                    if (!$document->isEmptyElement) {
                        $this->getNextElement($document);
                        if ('obi:Kod' === $document->name) {
                            $data['obec_kod'] = (int) $document->readString();
                        }
                    }

                    break;
                default:
                    $this->skipToElementEnd($document);

                    break;
            }
        } while ($this->getNextElement($document));

        if (empty($data['ulice_kod'])) {
            throw InvalidRuianDataException::becauseRequiredAttributeIsMissing($this->getName(), 'uli:Kod');
        }

        return new AddRecord($this->getName(), $data['ulice_kod'], $data);
    }
}
